Unit AFG3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AM12R_p;

procedure AFG3R(var A :Array of Real; var B :Array of Real;
                var Z :Array of Real; N :Integer; M :Integer);

implementation

procedure AFG3R(var A :Array of Real; var B :Array of Real;
                var Z :Array of Real; N :Integer; M :Integer);
var
K,K1,L,L1,LB,I,J,NK1,NM1,NM2 :Integer;
S,U2,T,V1,V2,RHO,R,U1,SD :Real;
WANTX :Boolean;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,_20,_21,_22;
begin
WANTX := False;
if ( M = 1 ) 
 then goto _3;
WANTX := True;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    Z[(I-1)+(J-1)*N] := ZERO;
_1:
   end;
  Z[(I-1)+(I-1)*N] := ONE;
_2:
 end;
_3:
NM1 := N-1;
if ( N <= 1 ) 
 then goto _22;
for L:=1 to NM1 do
 begin
  L1 := L+1;
  S := ZERO;
  for I:=L1 to N do
   begin
    S := S+Abs(B[(I-1)+(L-1)*N]);
_4:
   end;
  if ( S = ZERO ) 
   then goto _13;
  S := S+Abs(B[(L-1)+(L-1)*N]);
  R := ZERO;
  SD := ONE/S;
  for I:=L to N do
   begin
    B[(I-1)+(L-1)*N] := B[(I-1)+(L-1)*N]*SD;
    R := R+IntPower(B[(I-1)+(L-1)*N],2);
_5:
   end;
  R := Sqrt(R);
  if ( B[(L-1)+(L-1)*N] < ZERO ) 
   then R := -R;
  B[(L-1)+(L-1)*N] := B[(L-1)+(L-1)*N]+R;
  RHO := R*B[(L-1)+(L-1)*N];
  SD := ONE/RHO;
  for J:=L1 to N do
   begin
    T := ZERO;
    for I:=L to N do
     begin
      T := T+B[(I-1)+(L-1)*N]*B[(I-1)+(J-1)*N];
_6:
     end;
    T := -T*SD;
    for I:=L to N do
     begin
      B[(I-1)+(J-1)*N] := B[(I-1)+(J-1)*N]+T*B[(I-1)+(L-1)*N];
_7:
     end;
_8:
   end;
  for J:=1 to N do
   begin
    T := ZERO;
    for I:=L to N do
     begin
      T := T+B[(I-1)+(L-1)*N]*A[(I-1)+(J-1)*N];
_9:
     end;
    T := -T*SD;
    for I:=L to N do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]+T*B[(I-1)+(L-1)*N];
_10:
     end;
_11:
   end;
  B[(L-1)+(L-1)*N] := -S*R;
  for I:=L1 to N do
   begin
    B[(I-1)+(L-1)*N] := ZERO;
_12:
   end;
_13:
 end;
if ( N <= 2 ) 
 then goto _22;
NM2 := N-2;
for K:=1 to NM2 do
 begin
  K1 := K+1;
  NK1 := N-K1;
  for LB:=1 to NK1 do
   begin
    L := N-LB;
    L1 := L+1;
    AM12R(A[(L-1)+(K-1)*N],A[(L1-1)+(K-1)*N],U1,U2,V1,V2);
    if ( U1 <> ONE ) 
     then goto _16;
    for J:=K to N do
     begin
      T := A[(L-1)+(J-1)*N]+U2*A[(L1-1)+(J-1)*N];
      A[(L-1)+(J-1)*N] := A[(L-1)+(J-1)*N]+T*V1;
      A[(L1-1)+(J-1)*N] := A[(L1-1)+(J-1)*N]+T*V2;
_14:
     end;
    A[(L1-1)+(K-1)*N] := ZERO;
    for J:=L to N do
     begin
      T := B[(L-1)+(J-1)*N]+U2*B[(L1-1)+(J-1)*N];
      B[(L-1)+(J-1)*N] := B[(L-1)+(J-1)*N]+T*V1;
      B[(L1-1)+(J-1)*N] := B[(L1-1)+(J-1)*N]+T*V2;
_15:
     end;
_16:
    AM12R(B[(L1-1)+(L1-1)*N],B[(L1-1)+(L-1)*N],U1,U2,V1,V2);
    if ( U1 <> ONE ) 
     then goto _20;
    for I:=1 to L1 do
     begin
      T := B[(I-1)+(L1-1)*N]+U2*B[(I-1)+(L-1)*N];
      B[(I-1)+(L1-1)*N] := B[(I-1)+(L1-1)*N]+T*V1;
      B[(I-1)+(L-1)*N] := B[(I-1)+(L-1)*N]+T*V2;
_17:
     end;
    B[(L1-1)+(L-1)*N] := ZERO;
    for I:=1 to N do
     begin
      T := A[(I-1)+(L1-1)*N]+U2*A[(I-1)+(L-1)*N];
      A[(I-1)+(L1-1)*N] := A[(I-1)+(L1-1)*N]+T*V1;
      A[(I-1)+(L-1)*N] := A[(I-1)+(L-1)*N]+T*V2;
_18:
     end;
    if ( not WANTX ) 
     then goto _20;
    for I:=1 to N do
     begin
      T := Z[(I-1)+(L1-1)*N]+U2*Z[(I-1)+(L-1)*N];
      Z[(I-1)+(L1-1)*N] := Z[(I-1)+(L1-1)*N]+T*V1;
      Z[(I-1)+(L-1)*N] := Z[(I-1)+(L-1)*N]+T*V2;
_19:
     end;
_20:
   end;
_21:
 end;
_22:
end;

end.

