Unit AGT0R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFT0R_p, AM12R_p, AM12C_p, UTAG10_p;

procedure AGT0R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var ALFR :Array of Real;
                var ALFI :Array of Real; var BETA :Array of Real;
                N :Integer; var IERR :Integer);

implementation

procedure AGT0R(var A :Array of Real; var B :Array of Real;
                var V :Array of Real; var ALFR :Array of Real;
                var ALFI :Array of Real; var BETA :Array of Real;
                N :Integer; var IERR :Integer);
var
I,J,M,L,L1,K,MR,MI,IRET :Integer;
E,CZ,TI,V1,A21,B11,SQR,SZR,A11R,A21R,EPSA,AN,EI,TR,V2,A22,B12,SSI,
   A12I,A22I,EPSB,C,R,BN,ER,U1,A11,BDI,B22,SSR,A12R,A22R,D,T,CQ,U2,
   A12,BDR,SQI,SZI,A11I,A21I,DI,SLI,TLK,TKLR,TLLR,DR,SLR,TLL,ALMI,
   TKKI,TLKI,S,SK,SKI,TKK,ALMR,TKKR,TLKR,SL,SKR,TKL,ALFM,TKLI,TLLI,XR,
   XI,YR,YI,ZR,ZI,H,BETM,F,ANORM,BNORM,ANI,BNI,EPS :Real;
FLIP :Boolean;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
HALF :Real = 0.5;
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50;
begin
IERR := 0;
EPS := SYS051;
AFT0R(A,B,V,N,0,IERR);
ANORM := ZERO;
BNORM := ZERO;
for I:=1 to N do
 begin
  ANI := ZERO;
  if ( I <> 1 ) 
   then ANI := Abs(A[(I-1)+(I-2)*N]);
  BNI := ZERO;
  for J:=1 to N do
   begin
    ANI := ANI+Abs(A[(I-1)+(J-1)*N]);
    BNI := BNI+Abs(B[(I-1)+(J-1)*N]);
_1:
   end;
  if ( ANI > ANORM ) 
   then ANORM := ANI;
  if ( BNI > BNORM ) 
   then BNORM := BNI;
_2:
 end;
if ( ANORM = ZERO ) 
 then ANORM := EPS;
if ( BNORM = ZERO ) 
 then BNORM := EPS;
EPSA := EPS*ANORM;
EPSB := EPS*BNORM;
M := N;
_3:
if ( M = 1 ) 
 then goto _4;
if ( A[(M-1)+(M-2)*N] <> ZERO ) 
 then goto _5;
_4:
ALFR[M-1] := A[(M-1)+(M-1)*N];
if ( B[(M-1)+(M-1)*N] < ZERO ) 
 then ALFR[M-1] := -ALFR[M-1];
BETA[M-1] := Abs(B[(M-1)+(M-1)*N]);
ALFI[M-1] := ZERO;
M := M-1;
goto _16;
_5:
L := M-1;
if ( Abs(B[(L-1)+(L-1)*N]) > EPSB ) 
 then goto _6;
B[(L-1)+(L-1)*N] := ZERO;
AM12R(A[(L-1)+(L-1)*N],A[(M-1)+(L-1)*N],U1,U2,V1,V2);
goto _12;
_6:
if ( Abs(B[(M-1)+(M-1)*N]) > EPSB ) 
 then goto _7;
B[(M-1)+(M-1)*N] := ZERO;
AM12R(A[(M-1)+(M-1)*N],A[(M-1)+(L-1)*N],U1,U2,V1,V2);
BN := ZERO;
goto _8;
_7:
AN := Abs(A[(L-1)+(L-1)*N])+Abs(A[(L-1)+(M-1)*N])+Abs(A[(M-1)+(L-1)*N])+Abs(A[(M-1)+(M-1)*N]);
BN := Abs(B[(L-1)+(L-1)*N])+Abs(B[(L-1)+(M-1)*N])+Abs(B[(M-1)+(M-1)*N]);
F := ONE/AN;
A11 := A[(L-1)+(L-1)*N]*F;
A12 := A[(L-1)+(M-1)*N]*F;
A21 := A[(M-1)+(L-1)*N]*F;
A22 := A[(M-1)+(M-1)*N]*F;
F := ONE/BN;
B11 := B[(L-1)+(L-1)*N]*F;
B12 := B[(L-1)+(M-1)*N]*F;
B22 := B[(M-1)+(M-1)*N]*F;
E := A11/B11;
C := ((A22-E*B22)/B22-(A21*B12)/(B11*B22))*HALF;
D := C*C+(A21*(A12-E*B12))/(B11*B22);
if ( D < ZERO ) 
 then goto _15;
if ( C >= ZERO ) 
 then E := E+(C+Sqrt(D));
if ( C < ZERO ) 
 then E := E+(C-Sqrt(D));
A11 := A11-E*B11;
A12 := A12-E*B12;
A22 := A22-E*B22;
FLIP := ( (Abs(A11)+Abs(A12)) >= (Abs(A21)+Abs(A22)) );
if ( FLIP ) 
 then AM12R(A12,A11,U1,U2,V1,V2);
if ( not FLIP ) 
 then AM12R(A22,A21,U1,U2,V1,V2);
_8:
if ( U1 <> ONE ) 
 then goto _11;
for I:=1 to M do
 begin
  T := A[(I-1)+(M-1)*N]+U2*A[(I-1)+(L-1)*N];
  A[(I-1)+(M-1)*N] := A[(I-1)+(M-1)*N]+V1*T;
  A[(I-1)+(L-1)*N] := A[(I-1)+(L-1)*N]+V2*T;
  T := B[(I-1)+(M-1)*N]+U2*B[(I-1)+(L-1)*N];
  B[(I-1)+(M-1)*N] := B[(I-1)+(M-1)*N]+V1*T;
  B[(I-1)+(L-1)*N] := B[(I-1)+(L-1)*N]+V2*T;
_9:
 end;
for I:=1 to N do
 begin
  T := V[(I-1)+(M-1)*N]+U2*V[(I-1)+(L-1)*N];
  V[(I-1)+(M-1)*N] := V[(I-1)+(M-1)*N]+V1*T;
  V[(I-1)+(L-1)*N] := V[(I-1)+(L-1)*N]+V2*T;
_10:
 end;
_11:
if ( BN = ZERO ) 
 then goto _14;
FLIP := ( AN >= Abs(E)*BN );
if ( FLIP ) 
 then AM12R(B[(L-1)+(L-1)*N],B[(M-1)+(L-1)*N],U1,U2,V1,V2);
_12:
if ( U1 <> ONE ) 
 then goto _14;
if ( not FLIP ) 
 then AM12R(A[(L-1)+(L-1)*N],A[(M-1)+(L-1)*N],U1,U2,V1,V2);
for J:=L to N do
 begin
  T := A[(L-1)+(J-1)*N]+U2*A[(M-1)+(J-1)*N];
  A[(L-1)+(J-1)*N] := A[(L-1)+(J-1)*N]+V1*T;
  A[(M-1)+(J-1)*N] := A[(M-1)+(J-1)*N]+V2*T;
  T := B[(L-1)+(J-1)*N]+U2*B[(M-1)+(J-1)*N];
  B[(L-1)+(J-1)*N] := B[(L-1)+(J-1)*N]+V1*T;
  B[(M-1)+(J-1)*N] := B[(M-1)+(J-1)*N]+V2*T;
_13:
 end;
_14:
A[(M-1)+(L-1)*N] := ZERO;
B[(M-1)+(L-1)*N] := ZERO;
ALFR[L-1] := A[(L-1)+(L-1)*N];
ALFR[M-1] := A[(M-1)+(M-1)*N];
if ( B[(L-1)+(L-1)*N] < ZERO )
 then ALFR[L-1] := -ALFR[L-1];
if ( B[(M-1)+(M-1)*N] < ZERO )
 then ALFR[M-1] := -ALFR[M-1];
BETA[L-1] := Abs(B[(L-1)+(L-1)*N]);
BETA[M-1] := Abs(B[(M-1)+(M-1)*N]);
ALFI[M-1] := ZERO;
ALFI[L-1] := ZERO;
M := M-2;
goto _16;
_15:
ER := E+C;
EI := Sqrt(-D);
A11R := A11-ER*B11;
A11I := EI*B11;
A12R := A12-ER*B12;
A12I := EI*B12;
A21R := A21;
A21I := ZERO;
A22R := A22-ER*B22;
A22I := EI*B22;
FLIP := ( (Abs(A11R)+Abs(A11I)+Abs(A12R)+Abs(A12I))
    <= (Abs(A21R)+Abs(A22R)+Abs(A22I)) );
if ( FLIP ) 
 then AM12C(A12R,A12I,-A11R,-A11I,CZ,SZR,SZI);
if ( not FLIP ) 
 then AM12C(A22R,A22I,-A21R,-A21I,CZ,SZR,SZI);
FLIP := ( AN >= (Abs(ER)+Abs(EI))*BN );
if ( FLIP ) 
 then AM12C(CZ*B11+SZR*B12,SZI*B12,SZR*B22,
SZI*B22,CQ,SQR,SQI);
if ( not FLIP ) 
 then AM12C(CZ*A11+SZR*A12,SZI*A12,CZ*
A21+SZR*A22, SZI*A22,CQ,SQR,SQI);
SSR := SQR*SZR+SQI*SZI;
SSI := SQR*SZI-SQI*SZR;
TR := CQ*CZ*A11+CQ*SZR*A12+SQR*CZ*A21+SSR*A22;
TI := CQ*SZI*A12-SQI*CZ*A21+SSI*A22;
BDR := CQ*CZ*B11+CQ*SZR*B12+SSR*B22;
BDI := CQ*SZI*B12+SSI*B22;
R := Sqrt(BDR*BDR+BDI*BDI);
BETA[L-1] := BN*R;
ALFR[L-1] := AN*(TR*BDR+TI*BDI)/R;
ALFI[L-1] := AN*(TR*BDI-TI*BDR)/R;
TR := SSR*A11-SQR*CZ*A12-CQ*SZR*A21+CQ*CZ*A22;
TI := -SSI*A11-SQI*CZ*A12+CQ*SZI*A21;
BDR := SSR*B11-SQR*CZ*B12+CQ*CZ*B22;
BDI := -SSI*B11-SQI*CZ*B12;
R := Sqrt(BDR*BDR+BDI*BDI);
BETA[M-1] := BN*R;
ALFR[M-1] := AN*(TR*BDR+TI*BDI)/R;
ALFI[M-1] := AN*(TR*BDI-TI*BDR)/R;
M := M-2;
_16:
if ( M > 0 ) 
 then goto _3;
M := N;
_17:
if ( ALFI[M-1] <> ZERO ) 
 then goto _24;
ALFM := ALFR[M-1];
BETM := BETA[M-1];
B[(M-1)+(M-1)*N] := ONE;
L := M-1;
if ( L = 0 ) 
 then goto _23;
_18:
L1 := L+1;
SL := ZERO;
for J:=L1 to M do
 begin
  SL := SL+(BETM*A[(L-1)+(J-1)*N]-ALFM*B[(L-1)+(J-1)*N])*B[(J-1)+(M-1)*N];
_19:
 end;
if ( L = 1 ) 
 then goto _20;
if ( BETM*A[(L-1)+(L-2)*N] <> ZERO ) 
 then goto _21;
_20:
D := BETM*A[(L-1)+(L-1)*N]-ALFM*B[(L-1)+(L-1)*N];
if ( D = ZERO ) 
 then D := (EPSA+EPSB)*HALF;
B[(L-1)+(M-1)*N] := -SL/D;
L := L-1;
goto _23;
_21:
K := L-1;
SK := ZERO;
for J:=L1 to M do
 begin
  SK := SK+(BETM*A[(K-1)+(J-1)*N]-ALFM*B[(K-1)+(J-1)*N])*B[(J-1)+(M-1)*N];
_22:
 end;
TKK := BETM*A[(K-1)+(K-1)*N]-ALFM*B[(K-1)+(K-1)*N];
TKL := BETM*A[(K-1)+(L-1)*N]-ALFM*B[(K-1)+(L-1)*N];
TLK := BETM*A[(L-1)+(K-1)*N];
TLL := BETM*A[(L-1)+(L-1)*N]-ALFM*B[(L-1)+(L-1)*N];
D := TKK*TLL-TKL*TLK;
if ( D = ZERO ) 
 then D := (EPSA+EPSB)*HALF;
B[(L-1)+(M-1)*N] := (TLK*SK-TKK*SL)/D;
FLIP := ( Abs(TKK) >= Abs(TLK) );
if ( FLIP ) 
 then B[(K-1)+(M-1)*N] := -(SK+TKL*B[(L-1)+(M-1)*N])/TKK;
if ( not FLIP ) 
 then B[(K-1)+(M-1)*N] := -(SL+TLL*B[(L-1)+(M-1)*N])/TLK;
L := L-2;
_23:
if ( L > 0 ) 
 then goto _18;
M := M-1;
goto _35;
_24:
ALMR := ALFR[M-2];
ALMI := ALFI[M-2];
BETM := BETA[M-2];
MR := M-1;
MI := M;
B[(M-2)+(MR-1)*N] := ALMI*B[(M-1)+(M-1)*N]/(BETM*A[(M-1)+(M-2)*N]);
B[(M-2)+(MI-1)*N] := (BETM*A[(M-1)+(M-1)*N]-ALMR*B[(M-1)+(M-1)*N])/(BETM*A[(M-1)+(M-2)*N]);
B[(M-1)+(MR-1)*N] := ZERO;
B[(M-1)+(MI-1)*N] := -ONE;
L := M-2;
if ( L = 0 ) 
 then goto _34;
_25:
L1 := L+1;
SLR := ZERO;
SLI := ZERO;
for J:=L1 to M do
 begin
  TR := BETM*A[(L-1)+(J-1)*N]-ALMR*B[(L-1)+(J-1)*N];
  TI := -ALMI*B[(L-1)+(J-1)*N];
  SLR := SLR+TR*B[(J-1)+(MR-1)*N]-TI*B[(J-1)+(MI-1)*N];
  SLI := SLI+TR*B[(J-1)+(MI-1)*N]+TI*B[(J-1)+(MR-1)*N];
_26:
 end;
if ( L = 1 ) 
 then goto _27;
if ( BETM*A[(L-1)+(L-2)*N] <> ZERO ) 
 then goto _29;
_27:
DR := BETM*A[(L-1)+(L-1)*N]-ALMR*B[(L-1)+(L-1)*N];
DI := -ALMI*B[(L-1)+(L-1)*N];
IRET := 1;
XR := -SLR;
XI := -SLI;
YR := DR;
YI := DI;
goto _47;
_28:
B[(L-1)+(MR-1)*N] := ZR;
B[(L-1)+(MI-1)*N] := ZI;
L := L-1;
goto _34;
_29:
K := L-1;
SKR := ZERO;
SKI := ZERO;
for J:=L1 to M do
 begin
  TR := BETM*A[(K-1)+(J-1)*N]-ALMR*B[(K-1)+(J-1)*N];
  TI := -ALMI*B[(K-1)+(J-1)*N];
  SKR := SKR+TR*B[(J-1)+(MR-1)*N]-TI*B[(J-1)+(MI-1)*N];
  SKI := SKI+TR*B[(J-1)+(MI-1)*N]+TI*B[(J-1)+(MR-1)*N];
_30:
 end;
TKKR := BETM*A[(K-1)+(K-1)*N]-ALMR*B[(K-1)+(K-1)*N];
TKKI := -ALMI*B[(K-1)+(K-1)*N];
TKLR := BETM*A[(K-1)+(L-1)*N]-ALMR*B[(K-1)+(L-1)*N];
TKLI := -ALMI*B[(K-1)+(L-1)*N];
TLKR := BETM*A[(L-1)+(K-1)*N];
TLKI := ZERO;
TLLR := BETM*A[(L-1)+(L-1)*N]-ALMR*B[(L-1)+(L-1)*N];
TLLI := -ALMI*B[(L-1)+(L-1)*N];
DR := TKKR*TLLR-TKKI*TLLI-TKLR*TLKR;
DI := TKKR*TLLI+TKKI*TLLR-TKLI*TLKR;
if ( DR = ZERO ) and ( DI = ZERO ) 
 then DR := (EPSA+EPSB)*HALF;
IRET := 2;
XR := TLKR*SKR-TKKR*SLR+TKKI*SLI;
XI := TLKR*SKI-TKKR*SLI-TKKI*SLR;
YR := DR;
YI := DI;
goto _47;
_31:
B[(L-1)+(MR-1)*N] := ZR;
B[(L-1)+(MI-1)*N] := ZI;
FLIP := ( (Abs(TKKR)+Abs(TKKI)) >= Abs(TLKR) );
IRET := 3;
if ( FLIP ) 
 then goto _32;
XR := -SLR-TLLR*B[(L-1)+(MR-1)*N]+TLLI*B[(L-1)+(MI-1)*N];
XI := -SLI-TLLR*B[(L-1)+(MI-1)*N]-TLLI*B[(L-1)+(MR-1)*N];
YR := TLKR;
YI := TLKI;
goto _47;
_32:
XR := -SKR-TKLR*B[(L-1)+(MR-1)*N]+TKLI*B[(L-1)+(MI-1)*N];
XI := -SKI-TKLR*B[(L-1)+(MI-1)*N]-TKLI*B[(L-1)+(MR-1)*N];
YR := TKKR;
YI := TKKI;
goto _47;
_33:
B[(K-1)+(MR-1)*N] := ZR;
B[(K-1)+(MI-1)*N] := ZI;
L := L-2;
_34:
if ( L > 0 ) 
 then goto _25;
M := M-2;
_35:
if ( M > 0 ) 
 then goto _17;
M := N;
_36:
for I:=1 to N do
 begin
  S := ZERO;
  for J:=1 to M do
   begin
    S := S+V[(I-1)+(J-1)*N]*B[(J-1)+(M-1)*N];
_37:
   end;
  V[(I-1)+(M-1)*N] := S;
_38:
 end;
M := M-1;
if ( M > 0 ) 
 then goto _36;
M := N;
_39:
S := ZERO;
if ( ALFI[M-1] <> ZERO ) 
 then goto _42;
for I:=1 to N do
 begin
  R := Abs(V[(I-1)+(M-1)*N]);
  if ( R < S ) 
   then goto _40;
  S := R;
  D := V[(I-1)+(M-1)*N];
_40:
 end;
for I:=1 to N do
 begin
  V[(I-1)+(M-1)*N] := V[(I-1)+(M-1)*N]/D;
_41:
 end;
M := M-1;
goto _46;
_42:
for I:=1 to N do
 begin
  R := Abs(V[(I-1)+(M-2)*N])+Abs(V[(I-1)+(M-1)*N]);
  R := R*Sqrt(IntPower(V[(I-1)+(M-2)*N]/R,2)+IntPower(V[(I-1)+(M-1)*N]/R,2));
  if ( R < S ) 
   then goto _43;
  S := R;
  DR := V[(I-1)+(M-2)*N];
  DI := V[(I-1)+(M-1)*N];
_43:
 end;
IRET := 4;
I := 0;
_44:
I := I+1;
XR := V[(I-1)+(M-2)*N];
XI := V[(I-1)+(M-1)*N];
YR := DR;
YI := DI;
goto _47;
_45:
V[(I-1)+(M-2)*N] := ZR;
V[(I-1)+(M-1)*N] := ZI;
if ( I < N ) 
 then goto _44;
M := M-2;
_46:
if ( M > 0 ) 
 then goto _39;
goto _50;
_47:
if ( Abs(YR) < Abs(YI) ) 
 then goto _48;
H := YI/YR;
F := YR+H*YI;
ZR := (XR+H*XI)/F;
ZI := (XI-H*XR)/F;
goto _49;
_48:
H := YR/YI;
F := YI+H*YR;
ZR := (H*XR+XI)/F;
ZI := (H*XI-XR)/F;
_49:
case IRET of
 1: goto _28;
 2: goto _31;
 3: goto _33;
 4: goto _45;
end;
_50:
if ( IERR <> 0 ) 
 then UTAG10(IERR,41);
end;

end.
